Loading...
Searching...
No Matches
pcl::Filter< pcl::PCLPointCloud2 > Class Referenceabstract
Module filters

Filter represents the base filter class. More...

`#include <pcl/filters/filter.h>`

Inheritance diagram for pcl::Filter< pcl::PCLPointCloud2 >:

## Public Types

using | Ptr = shared_ptr<Filter<pcl::PCLPointCloud2> >
using | ConstPtr = shared_ptr<const Filter<pcl::PCLPointCloud2> >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
using | PCLPointCloud2 = pcl::PCLPointCloud2
using | PCLPointCloud2Ptr = PCLPointCloud2::Ptr
using | PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr

## Public Member Functions

| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor.
virtual | ~PCLBase ()=default
| destructor.
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset.
PCLPointCloud2ConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
IndicesPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const pcl::PCLPointCloud2 & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

virtual void | applyFilter (PCLPointCloud2 &output)=0
| Abstract filter method.
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

IndicesPtr | removed_indices_
| Indices of the points that are removed.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
std::string | filter_name_
| The filter name.
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.
std::vector< uindex_t > | field_sizes_
| The size of each individual field.
index_t | x_idx_
| The x-y-z fields indices.
index_t | y_idx_
index_t | z_idx_
std::string | x_field_name_
| The desired x-y-z field names.
std::string | y_field_name_
std::string | z_field_name_

## Detailed Description

Filter represents the base filter class.

All filters must inherit from this interface.

Author
  Radu B. Rusu

Definition at line 186 of file filter.h.

## Member Typedef Documentation

## ConstPtr

using pcl::Filter< pcl::PCLPointCloud2 >::ConstPtr = shared_ptr<const Filter<pcl::PCLPointCloud2> >

Definition at line 190 of file filter.h.

## PCLPointCloud2

using pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2 = pcl::PCLPointCloud2

Definition at line 192 of file filter.h.

## PCLPointCloud2ConstPtr

using pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2ConstPtr = PCLPointCloud2::ConstPtr

Definition at line 194 of file filter.h.

## PCLPointCloud2Ptr

using pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2Ptr = PCLPointCloud2::Ptr

Definition at line 193 of file filter.h.

## PointCloud

using pcl::Filter< pcl::PCLPointCloud2 >::PointCloud

Definition at line 87 of file filter.h.

## PointCloudConstPtr

using pcl::Filter< pcl::PCLPointCloud2 >::PointCloudConstPtr

Definition at line 89 of file filter.h.

## PointCloudPtr

using pcl::Filter< pcl::PCLPointCloud2 >::PointCloudPtr

Definition at line 88 of file filter.h.

## Ptr

using pcl::Filter< pcl::PCLPointCloud2 >::Ptr = shared_ptr<Filter<pcl::PCLPointCloud2> >

Definition at line 189 of file filter.h.

## Constructor & Destructor Documentation

## Filter()

pcl::Filter< pcl::PCLPointCloud2 >::Filter | ( | bool | extract_removed_indices = false | ) |

inline

Empty constructor.

Parameters

  [in] | extract_removed_indices | set to true if the filtered data indices should be saved in a separate list. Default: false.

Definition at line 200 of file filter.h.

References extract_removed_indices_, and removed_indices_.

Referenced by pcl::FilterIndices< pcl::PCLPointCloud2 >::FilterIndices().

## Member Function Documentation

## applyFilter()

virtual void pcl::Filter< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

protected pure virtual

Abstract filter method.

The implementation needs to set output.{data, row_step, point_step, width, height, is_dense}.

Parameters

  [out] | output | the resultant filtered point cloud

Implemented in pcl::CropBox< pcl::PCLPointCloud2 >, pcl::ExtractIndices< pcl::PCLPointCloud2 >, pcl::FilterIndices< pcl::PCLPointCloud2 >, pcl::PassThrough< pcl::PCLPointCloud2 >, pcl::ProjectInliers< pcl::PCLPointCloud2 >, pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >, pcl::RandomSample< pcl::PCLPointCloud2 >, pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >, and pcl::VoxelGrid< pcl::PCLPointCloud2 >.

## filter()

void pcl::Filter< pcl::PCLPointCloud2 >::filter | ( | PCLPointCloud2 & | output | ) |

Calls the filtering method and returns the filtered dataset in output.

Parameters

  [out] | output | the resultant filtered point cloud dataset

## getClassName()

const std::string & pcl::Filter< pcl::PCLPointCloud2 >::getClassName | ( |  | ) | const

inline protected

Get a string representation of the name of this class.

Definition at line 250 of file filter.h.

References filter_name_.

## getRemovedIndices() [1/2]

IndicesConstPtr const pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices | ( |  | ) | const

inline

Get the point indices being removed.

Definition at line 208 of file filter.h.

References removed_indices_.

## getRemovedIndices() [2/2]

void pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices | ( | PointIndices & | pi | ) |

inline

Get the point indices being removed.

Parameters

  [out] | pi | the resultant point indices that have been removed

Definition at line 217 of file filter.h.

References pcl::PointIndices::indices, and removed_indices_.

## Member Data Documentation

## extract_removed_indices_

bool pcl::Filter< pcl::PCLPointCloud2 >::extract_removed_indices_

protected

Set to true if we want to return the indices of the removed points.

Definition at line 234 of file filter.h.

Referenced by Filter().

## filter_name_

std::string pcl::Filter< pcl::PCLPointCloud2 >::filter_name_

protected

The filter name.

Definition at line 237 of file filter.h.

Referenced by pcl::CropBox< pcl::PCLPointCloud2 >::CropBox(), pcl::ExtractIndices< pcl::PCLPointCloud2 >::ExtractIndices(), getClassName(), pcl::PassThrough< pcl::PCLPointCloud2 >::PassThrough(), pcl::ProjectInliers< pcl::PCLPointCloud2 >::ProjectInliers(), pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::RadiusOutlierRemoval(), pcl::RandomSample< pcl::PCLPointCloud2 >::RandomSample(), pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::StatisticalOutlierRemoval(), and pcl::VoxelGrid< pcl::PCLPointCloud2 >::VoxelGrid().

## removed_indices_

IndicesPtr pcl::Filter< pcl::PCLPointCloud2 >::removed_indices_

protected

Indices of the points that are removed.

Definition at line 231 of file filter.h.

Referenced by pcl::ExtractIndices< pcl::PCLPointCloud2 >::applyFilterIndices(), Filter(), getRemovedIndices(), and getRemovedIndices().

The documentation for this class was generated from the following file:

- pcl/filters/filter.h